procedure MyOwnStatInit();
var
  sql, names, name_query	: String;				//SQL dotaz
  table						: TSQLiteTable;			//Tabulka
  i							: integer;
  Year, Month, Day 			: word;					//
  nlist 					: TStringList;
begin
    //ShowMessage(GEOGET_DBNAME + ' ' + GEOGET_OWNER + ' ' + GEOGET_OWNERS);
	//-------Dekoduje z okamitho asu a datumu jen datum----------------------
	DecodeDate(Now, Year, Month, Day);
	Today := EncodeDate(Year, Month, Day);
	nlist := TStringList.Create;
	names := GEOGET_OWNERS;
	//ShowMessage(names);
	//
	name_query := '';
	repeat 
		nlist.Add(Fetch(names, ','));
	until length(names) = 0;
	//
	for i := 0 to nlist.Count-1 do begin
		if i > 0 then name_query := name_query + ' or ';
		name_query := name_query + 'author like ''%' + nlist[i] + '%''';
	end;
	//
	name_query := name_query + ' ';
	//
	//ShowMessage(name_query);
	//
	//SQL-----------------------------------------------------------------------
	//			     %0%						%1%								%2%        %3%			  %4%
	sql := 'select gc.id, replace(replace(gc.name,'''',''>''),"''","") name, gc.guid, gc.gs_ownerid, gc.cachetype,';
	//		        	%5%
	sql := sql + ' gc.dthidden,';
	//					%6%
	sql := sql + ' CASE WHEN cachestatus = 2';
    sql := sql + ' THEN (SELECT CAST(gl.dt AS integer) FROM geolog gl WHERE gl.id = gc.id and gl.type = ''Archive'' ORDER BY CAST(gl.dt AS integer) DESC LIMIT 1)';   
    sql := sql + ' ELSE -1';
	sql := sql + ' END enddatetime,';
	//					%7%			  %8%		  %9%
	sql := sql + ' gc.difficulty, gc.terrain, gc.cachesize,';
	//												%10%
	sql := sql + ' ifnull((select value from geotagvalue where key = gt.ptrvalue),0) elevation,';
	//					%11%
	sql := sql + ' MIN(CASE WHEN ifnull(gl.dt,'''') = ''''';
	sql := sql + '   THEN (select glx.dt from geolog glx where gc.id = glx.id and glx.type = ''Found it'' order by glx.dt ASC LIMIT 1)';     
	sql := sql + '   ELSE gl.dt';     
	sql := sql + ' END) dtpublish,';
	//                                  %12%
	sql := sql + ' ifnull((select value from geotagvalue where key = gt0.ptrvalue),0) fp,';
	//											%13%																				%14%
	sql := sql + ' ifnull((select value from geotagvalue where key = gt1.ptrvalue),''0x'') GCVCount, ifnull((select value from geotagvalue where key = gt2.ptrvalue), 0) GCVMedian,';
	//											%15%																				%16%
	sql := sql + ' ifnull((select value from geotagvalue where key = gt3.ptrvalue),''0x'') CZCount, ifnull((select value from geotagvalue where key = gt4.ptrvalue), 0) CZValue,';
	//															%17%
	sql := sql + ' (select count(*) from geolog glx where glx.id = gc.id and (glx.type = ''Found it'' or glx.type = ''Attended'')) FoundIt,';
	//		        	%18%
	sql := sql + ' gc.cachestatus';
	sql := sql + ' from geocache gc';
	sql := sql + ' left join geolog gl on (gc.id = gl.id and gl.type = ''Publish Listing'')';
	sql := sql + ' left join geotag gt on (gc.id = gt.id and gt.ptrkat = (select key from geotagcategory where value = ''Elevation''))';
	sql := sql + ' left join geotag gt0 on (gc.id = gt0.id and gt0.ptrkat = (select key from geotagcategory where value = ''favorites''))'
	sql := sql + ' left join geotag gt1 on (gc.id = gt1.id and gt1.ptrkat = (select key from geotagcategory where value = ''GCvote-Count''))'
	sql := sql + ' left join geotag gt2 on (gc.id = gt2.id and gt2.ptrkat = (select key from geotagcategory where value = ''GCvote-median''))'
	sql := sql + ' left join geotag gt3 on (gc.id = gt3.id and gt3.ptrkat = (select key from geotagcategory where value = ''Hodnoceni-Pocet''))'
	sql := sql + ' left join geotag gt4 on (gc.id = gt4.id and gt4.ptrkat = (select key from geotagcategory where value = ''Hodnoceni''))'
	//sql := sql + ' where author like ''%' + AnsiToUtf(GEOGET_OWNER) + '%''';
	sql := sql + ' where ' + name_query;
	//
	sql := sql + ' group by gc.id';
	sql := sql + ' order by dtpublish ASC';
	//hodnota
	//ShowHTMLMessage('test',sql);
	table := GEOGET_DB.GetTable(sql, false);
	//
	iniFile := TIniFile.Create(GEOGET_SCRIPTDIR + '\MyOwnStat\' + INI_FILE);
	//
	i := 0;
	//	
	try	//table
	  try	//ini
		//Nate vlastn kee do seznamu OwnCache
		maxDays := 0;
		while not table.Eof do begin
			Inc(OCCount);
			SetLength(OwnCache, OCCount);
			with OwnCache[OCCount-1] do begin
				ID 			:= table.FieldAsString(0);
				CName		:= Trim(UtfToAnsi(table.FieldAsString(1)));	
				//ShowMessage(CName);
				CGuid		:= table.FieldAsString(2);
				COwnerID	:= table.FieldAsString(3);
				CStatus		:= table.FieldAsInteger(18);
				CType		:= table.FieldAsString(4);
				CHDatum    	:= IntToDate(table.FieldAsString(5));		//Datum ukryt sed
				//
				CDifficult	:= table.FieldAsString(7);
				CTerrain	:= table.FieldAsString(8);
				CSize		:= table.FieldAsString(9);
				CElevation  := table.FieldAsString(10);
				//Public
				CDtPublic	:= IntToDate(table.FieldAsString(11));		//pokud nejsou logy v DB me to bt chybn !!
				//Favorite points
				FP			:= StrToInt(table.FieldAsString(12));
				//GCVote
				GCCount		:= table.FieldAsString(13)
				GCMedian	:= StrToFl(table.FieldAsString(14));
				//CZVote
				CZCount		:= table.FieldAsString(15);
				CZVoteStr	:= table.FieldAsString(16);
				CZVote		:= (StrToInt(ReplaceString(CZVoteStr, '%', ''))*5)/100.00;
				CCFoundIt	:= table.FieldAsString(17);
				//z INI
				CShow		:= iniFile.ReadBool(ID,'Show',True);
				CFTF		:= iniFile.ReadString(ID,'FTF','');
				CSTF		:= iniFile.ReadString(ID,'STF','');
				CTTF		:= iniFile.ReadString(ID,'TTF','');
				//
				if table.FieldAsInteger(6) < 0 then begin
					CADatum := Today;
					CArchived := False;
				end
				else begin
					CADatum := IntToDate(table.FieldAsString(6));
					CArchived := True;
				end;
				if maxDays < (Trunc(CADatum - CHDatum) + 1) then maxDays := Trunc(CADatum - CHDatum) + 1;
				Inc(i);
			end;
			table.Next; 
		end;
		//ShowMessage(IntToStr(i))
      finally
		if(iniFile <> nil) then iniFile.Free;
	  end;		
	finally
		nlist.Free;
		if(table <> nil) then table.Free();
	end;
end;

function FindValue(gr : array of TGraf; const dday : integer): integer;
var
	i,j	: integer;
begin
	Result := (-1);
	//
	For i := Low(gr) to High(gr) do begin
		if gr[i].Day = dday then begin
			//ShowMessage(IntToStr(dday) + '-' + IntToStr(gr[i].Value) + '/' + IntToStr(i));
			For j := i to High(gr) do begin
				if gr[j].opt then begin
					Result := gr[j].Value;
					Break;
				end;
			end;
		end;
	end;
end;

procedure BreakWork;
begin
	if MessBox(_('Do you cancel the plug-in work?'), _('MyOwnStat:: Cancel?'), 4) = 6 then RaiseException(ErCustomError,'End');
end;

function Hvezdicky(hodnota : extended) : String;
begin
	if hodnota <= 1 then Result := 'stars1.gif'
	else if (hodnota > 1) and (hodnota <= 1.5) then Result := 'stars1_5.gif'
	else if (hodnota > 1.5) and (hodnota <= 2) then Result := 'stars2.gif'
	else if (hodnota > 2) and (hodnota <= 2.5) then Result := 'stars2_5.gif'
	else if (hodnota > 2.5) and (hodnota <= 3) then Result := 'stars3.gif'
	else if (hodnota > 3) and (hodnota <= 3.5) then Result := 'stars3_5.gif'
	else if (hodnota > 3.5) and (hodnota <= 4) then Result := 'stars4.gif'
	else if (hodnota > 4) and (hodnota <= 4.5) then Result := 'stars4_5.gif'
	else Result := 'stars5.gif';
end;

function alphabetic ( ch : char ) : boolean;
begin
    if ( ((ch >= 'a') AND (ch <= 'z')) OR ((ch >= 'A') AND (ch <= 'Z')) OR ((ch >= '0') AND (ch <= '9')) 
	   OR (ch = '_') OR (ch = '[') OR (ch = ']') OR (ch = '(') OR (ch = ')') OR (ch = ':') OR (ch = ';')
	   OR (ch = '!') OR (ch = '?') OR (ch = '}') OR (ch = '{') OR (ch = '^')) then
       Result := TRUE
    else
       Result := FALSE;
end;

{ a function to count the number of words in a string }
function count_words ( var line : string ) : integer;
var  i, word_count : integer;
     looking_for_word : boolean;
begin
    looking_for_word := TRUE;
    word_count := 0;
    for i := 1 to length(line) do
    begin
        if alphabetic( line[i] ) then
        begin
           if looking_for_word then
           begin
               word_count := word_count + 1;
               looking_for_word := FALSE
           end
        end
        else
           looking_for_word := TRUE;
    end;
    Result := word_count
end;

function myAnsiToUtf(txt:String):String;
begin
	if MOSForm_cbEncode.ItemIndex > 0 then
		Result := AnsiToUtf(txt)
	else
		Result := txt;
end;

function CreateHTML(silent:boolean): String;
var
  sql		: String;				//SQL dotaz
  table		: TSQLiteTable;			//Tabulka
  i,j,k,m,n	: integer;
  h1,h2		: integer;
  LCount	: integer;
  GCount	: integer;
  DCount	: integer;
  ACount	: integer;
  dcnt		: integer;
  dcnt2		: integer;
  IsArchive	: integer;
  IsDisable	: boolean;
  LFo,LNf	: integer;
  Dis,Arch	: integer;
  archivedt	: TDateTime;
  exist		: integer;
  lostdays	: integer;
  ddays		: integer;
  adays		: integer;
  Logs		: array of TFlog;		//Logy pro zpracovn
  stime		: TDateTime;			//poten (start) as
  ZeroDay	: TDateTime;			//den nula
  LastFound	: TDateTime;			//naposledy nalezeno
  LastFinder: String;				//posledn nlezce
  Reviewer	: String;				//reviewer
  graf		: array of TGraf;		//prbh grafu found
  disable	: array of TGraf;		//disable sti - jsou-li
  archive	: array of TGraf;		//archive sti - jsou-li
  pomdate	: TDateTime;
  gFound	: String;
  gNFound	: String;
  gDisable	: String;
  gArchive	: String;
  gData		: String;
  gMarks    : String;
  gGraphs	: String;
  gColors   : String;
  gHints	: String;
  cachetype : String;
  st1,st2	: String;
  st1x,st2y	: String;
  otxt		: String;				//pomocn text
  outtxt	: String;				//vstupn text
  eouttxt	: String;				//eventy text
  eaouttxt	: String;				//eventy archivovan text
  couttxt	: String;				//cache text
  caouttxt	: String;				//cache archivovan text
  statxt	: String;				//statistika text
  headertxt	: String;				//hlavika Stator
  maxy		: integer;
  maxx		: integer;
  gg,ga		: Boolean;
  efectivity: extended;
  efectreal : extended;
  CountW	: integer;
  //FP		: integer;
  WA		: integer;
  GCStar	: String;
  CZStar	: String;
  Size		: String;
  Terrain	: String;
  Difficult	: String;
  FTF		: String;
  STF		: String;
  TTF		: String;
  Arc		: Integer;
  succolor	: String;				//Success color
  //tmpstr	: String;
  tmpval	: integer;
  firstval	: integer;
  //
  pgwidth	: Integer;				//ka strnky
  txwidth	: Integer;				//ka textu vedle grafu
  //
  XTime		: TDateTime;
  //Statistic
  MyCaches	: integer;
  MyEvents	: integer;
  MyAEvents	: integer;
  TotalFound: integer;
  TotalDays : integer;
  MostFound : integer;
  MostFCache: integer;
  MostFP	: integer;
  MostFPCache: integer;
  MostFrq	: extended;
  MostFrqCache: integer;
  TotalFP	: integer;
  MostLogLength: integer;
  MostLLCache: integer;
  MaxAverageLenght: integer;
  Dayly		: array of TFDayly;		//Denn logy
  YearlyMax	: array of TGYear;		//Ron maxima u ke
  DlyCnt	: integer;
  Dlyflg	: boolean;
  CacheFound: integer;
  TotalWords: integer;
  //
  pomCW		: integer;
  Caches	: integer;
  Aperc		: extended;
  //
  pubyes	: boolean;
  list 		: TStringList;
  tmp		: String;
  //YEARS
  ehtxt		: String;
  eahtxt	: String;
  cctxt		: String;
  years		: word;
  year		: word;
  nyear		: word;  
  myear		: word; 
  mday  	: word;
  mmonth	: word;
  
begin
    try
		//Stat init
		MyCaches := 0; MyEvents	:= 0; MyAEvents	:= 0;	//OK
		TotalFound := 0 ; TotalDays := 0;				//OK
		MostFound := 0; MostFCache := 0;				//OK
		MostFP := 0; MostFPCache := 0;					//OK
		MostFrq	:= 0; MostFrqCache := 0;				//OK
		TotalFP	:= 0; MostLogLength := 0;				//OK
		MostLLCache := 0; MaxAverageLenght := 0;		//OK
		DlyCnt := 0; CacheFound := 0;					//OK
		TotalWords := 0;								//OK
		//
		Result := '';
		outtxt := ''; ehtxt := ''; eahtxt := '';
		couttxt := ''; caouttxt := '';
		eouttxt := ''; eaouttxt := ''; headertxt := '';
		//List
		list := TStringList.Create;
		tmp := GEOGET_DATADIR + '\mos_err.ggt';
		if FileExists(tmp) then DeleteFile(tmp);
		//Language
		if Trim(MOSForm_cbLang.Items[MOSForm_cbLang.ItemIndex]) = 'CZ' then
			UseLanguage('CS')
		else
			UseLanguage('EN');
		//
		sql := 'SELECT COUNT(*) FROM Geocache gc WHERE gc.dtfound > 0';
		CacheFound := GEOGET_DB.GetTableValue(sql);
		sql := '';
		//
		pgwidth := StrToInt(iWidth); //StrToInt(sWidth);
		txwidth := pgwidth - GWidth - 5;
		//
		if MOSForm_chbStator.checked then begin
			headertxt := headertxt + '<div style="margin:25px 3px 10px 3px; background:#%ColorTitleBkg%; color:#%ColorTitleText%; font-weight:bold; line-height:20px; font-size:13px; border: 1px solid #%ColorTitleBorder%; text-align:center;">' + _('My Own cache/events stats') + '</div>' + CRLF + '<br />' + CRLF;
		end;
		//
		outtxt := outtxt + '<div class="MOS_tlacitka" style="text-align: center; display: %show%">' + CRLF;
		outtxt := outtxt + '<span onmousedown="for(var i = 1; i < %arch% ; i++) {document.getElementById(''MyOwnArc'' + i).style.display = '''';}" style="border: 1px solid #000000; cursor: pointer; padding: 1px; background: #ffffff; color: #000000;"><i><b>  ' + _('Show Archived') + '  </b></i></span> &nbsp;&nbsp;';  
		outtxt := outtxt + '<span onmousedown="for(var i = 1; i < %arch% ; i++) {document.getElementById(''MyOwnArc'' + i).style.display = ''none'';}" style="border: 1px solid #000000; cursor: pointer; padding: 1px; background: #000000; color: #ffffff;"><i><b>  ' + _('Hide Archived') + '  </b></i></span></div>' + CRLF;
		//
		outtxt := outtxt + '<br /><br />' + CRLF;
		//outtxt := outtxt + '<hr width="' + IntToStr(pgwidth) + 'px" size="1" noshade />';
		//
		UseLanguage('');
		//
		ZeroDay := IntToDate('19990101');
		maxx := 0; maxy :=0; Arc := 0; year := 0;
		XTime := Now;
		//ShowMessage(IntToStr(maxdays));
		//--------------------------------------------------------------------------
		//YEAR
		if MOSForm_chbYears.checked then begin
		years := 0;
			For i := Low(OwnCache) to High(OwnCache) do begin
				//tmpstr := OwnCache[i].CName + ' max: ' + OwnCache[i].CCFoundIt + ' year: ' + DateToStr(OwnCache[i].CDtPublic) + CRLF;
				DecodeDate(OwnCache[i].CDtPublic, myear, mmonth, mday);
				if myear > year then begin 
					year := myear;
					Inc(years)
					SetLength(YearlyMax, years + 1);
					maxy := 0;
				end;		//reset size X
				dcnt := StrToInt(OwnCache[i].CCFoundIt);
				if dcnt > maxy then begin 
					maxy := dcnt;
					YearlyMax[years].MaxY := maxy + 5;	//+5 aby to bylo hez
					YearlyMax[years].Year := myear;
					//tmpstr := tmpstr + OwnCache[i].CName + ' max: ' + IntToStr(maxy) + ' year: ' + DateToStr(OwnCache[i].CDtPublic);
				end;
				//ShowMessage(tmpstr);
			end;
			year := 0; maxy := 0;  nyear := 0;
		end;
		//----
		For i := Low(OwnCache) to High(OwnCache) do begin
			//
			if GeoBusyTest then BreakWork;
			//
			otxt := '';
			//
			if not OwnCache[i].CShow then continue;		//pesko kee kter nechceme zobrazit ------>>
			//
			GeoBusyKind(OwnCache[i].CName);
			GeoBusyProgress(i+1,OCCount);
			//
			//				%0%
			sql := 'select gl.dt,';
			//				 %1%		%2%		   %3%			  %4%
			sql := sql + ' gl.type, gl.finder, gl.logtext, gl.gs_finderid';
			sql := sql + ' from geolog gl';	
			sql := sql + ' where gl.id = ''' + OwnCache[i].ID + '''';
			sql := sql + ' order by gl.dt ASC, gl.type DESC ';
			//ShowHTMLMessage('test',sql);
			//tabulka sql-----------------------------------------------------------
			table := GEOGET_DB.GetTable(sql, false);
			//zpracovani tabulky----------------------------------------------------
			//nulovani
			archivedt := Today;
			LastFound := ZeroDay;
			lostdays := 0; adays := 0; ddays := 0;		
			IsArchive := -1; IsDisable := False;
			LCount := 0; GCount := 0; DCount := 0; {GnfCount := 0;} ACount := 0;
			SetLength(Logs, LCount);
			SetLength(graf, GCount);
			//SetLength(grafnf, GnfCount);
			SetLength(disable, DCount);
			SetLength(archive, ACount);
			LFo := 0; LNf := 0;
			Dis := 0; Arch := 0;
			CountW := 0; WA := 0;
			gGraphs :=''; gData := ''; gMarks := '';
			GCStar := ''; FTF := ''; STF := ''; TTF := '';
			pubyes := false; Reviewer := ''; LastFinder := '';
			//----------------------------------------------------------------------
			//XTime := Now;
			try	//table
				//Nate vlastn kee do seznamu OwnCache
				while not table.Eof do begin
					Inc(LCount);						//+1
					SetLength(Logs, LCount);			//pam + 1
					with Logs[LCount-1] do begin
						if GeoBusyTest then BreakWork;
						LogDate		:= IntToDate(table.FieldAsString(0));
						LType		:= table.FieldAsString(1);
						LFinder		:= UtfToAscii(table.FieldAsString(2));
						if MOSForm_chbWord.checked then begin
							if not ((OwnCache[i].CType = 'Event Cache') or 
							(OwnCache[i].CType = 'Cache In Trash Out Event') or
							(OwnCache[i].CType = 'Lost and Found Event Cache') or
							(OwnCache[i].CType = 'Mega-Event Cache'))
							then begin
								LLog	:= zDecompress(table.FieldAsBlobText(3));
								//slova v lozch poet
								pomCW	:= count_words(LLog);
								CountW	:= CountW + pomCW;
								if pomCW > MostLogLength then begin
									MostLogLength := pomCW;
									MostLLCache := i;
								end;
							end;
						end;
						LFinderID	:= table.FieldAsString(4);
						//----------------------------------------------------------
						if (LType = 'Found it') or (LType = 'Attended') then begin
							Inc(LFo);
							if LastFound = LogDate then begin
								LastFinder := LastFinder + ', ' + LFinder;
							end
							else begin
								LastFound := LogDate;
								LastFinder := LFinder;
							end;
							//dny logovn
							Dlyflg := False;
							if DlyCnt > 0 then begin								
								For j := Low(Dayly) to High(Dayly) do begin 
									if Dayly[j].LogDate = LogDate then begin
										Dlyflg := True;
										Inc(Dayly[j].LogCount);
										break;
									end;
								end;
							end;
							if not Dlyflg then begin
								Inc(DlyCnt);
								SetLength(Dayly, DlyCnt);
								Dayly[DlyCnt-1].LogDate := LogDate;
								Dayly[DlyCnt-1].LogCount := 1;
							end;
						end;
						if LType = 'Will Attend' then Inc(WA);
						if LType = 'Didn''t find it' then Inc(LNf);
						//
						if LType = 'Publish Listing' then begin
							//stime := LogDate;
							Reviewer := LFinder;
							pubyes := true;
						end;
						if LType = 'Temporarily Disable Listing' then Inc(Dis);
						if LType = 'Archive' then begin
							archivedt := LogDate;
							Inc(Arch);
						end;
						if (LType = 'Archive/Unarchive') or (LType = 'Unarchive') then archivedt := Today;
					end;
					table.Next;				
				end;
			finally
				if(table <> nil) then table.Free();
			end;
			//ShowMessage('test');
			//ShowHTMLMessage('Logy','found = ' + IntToStr(LFo) + ' Posledn nlez = ' + LastFinder + ' celkov logy = ' + IntToStr(LCount));
			//------doladeni dat v polich-------------------------------------------
			stime := OwnCache[i].CDtPublic{ := stime};				//as publikace
			if archivedt = Today then begin
				//ShowMessage('test 1');
				OwnCache[i].CExist := Trunc(Today - stime) + 1;		//dlka existence kee ve dnech - ijc
				exist := Trunc(Today - OwnCache[i].CHDatum) + 1;	//cel existence ode dne skryt
			end
			else begin
				//ShowMessage('test 2');
				OwnCache[i].CExist := Trunc(archivedt - stime) + 1;	//dlka existence kee ve dnech - archivovan
				exist := Trunc(archivedt - OwnCache[i].CHDatum) + 1;//cel existence ode dne skryt
			end;
			OwnCache[i].CLogs := LCount;							//poet log
			OwnCache[i].CFoundIt := LFo;							//logy found
			OwnCache[i].CNotFound := LNf;							//logy not found
			//
			TotalFound := TotalFound + LFo;							//vechny nlezy/attendy za vechny kee
			if LFo > MostFound then begin
				MostFound := LFo;
				MostFCache := i;
			end;
			//
			try
				efectivity := (LFo * 1.00) / (OwnCache[i].CExist - 1.00);			//efektivita za celou ivotnost
			except
				efectivity := 0;
			end;
			if not ((OwnCache[i].CType = 'Event Cache') or 
			   (OwnCache[i].CType = 'Cache In Trash Out Event') or
			   (OwnCache[i].CType = 'Lost and Found Event Cache') or
			   (OwnCache[i].CType = 'Mega-Event Cache'))
			then begin
				//jen pro CACHE
				if efectivity > MostFrq then begin
					MostFrq := efectivity;
					MostFrqCache := i;
				end;
			end;
			if OwnCache[i].FP > MostFP then begin
				MostFP := OwnCache[i].FP;
				MostFPCache := i;
			end;
			TotalFP := TotalFP + OwnCache[i].FP;
			//------------------------------------------------------------------
			if MOSForm_chbGCVote.checked then GCStar := Hvezdicky(OwnCache[i].GCMedian);
			if MOSForm_chbCzechVote.checked then CZStar := Hvezdicky(OwnCache[i].CZVote);
			Terrain	:= Hvezdicky(StrToFl(OwnCache[i].CTerrain));
			Difficult := Hvezdicky(StrToFl(OwnCache[i].CDifficult));
			//------------------------------------------------------------------
			//obtnost
			case OwnCache[i].CSize of
				'Micro'	: Size := 'micro.gif';
				'Small'	: Size := 'small.gif';
				'Regular' : Size := 'regular.gif';
				'Large' : Size := 'large.gif';
				'Not chosen' : Size := 'not_chosen.gif';
				'Other' : Size := 'other.gif';
				'Virtual' : Size := 'virtual.gif';
			end;
			//------------------------------------------------------------------
			case OwnCache[i].CType of
				'Traditional Cache'				: cachetype := '2.gif';
				'Multi-cache'					: cachetype := '3.gif';
				'Unknown Cache'					: cachetype := '8.gif';
				'Virtual Cache'					: cachetype := '4.gif';
				'Webcam Cache'					: cachetype := '11.gif';
				'Wherigo Cache'					: cachetype := '1858.gif';
				'Letterbox Hybrid'				: cachetype := '5.gif';
				'Event Cache'					: cachetype := '6.gif';
				'Cache In Trash Out Event'		: cachetype := '13.gif';
				'Mega-Event Cache'				: cachetype := '453.gif';
				'Lost and Found Event Cache'	: cachetype := '3653.gif';
				'Earthcache'					: cachetype := 'earthcache.gif';
			else cachetype := '?';
			end;		
			//------vytvoreni dat pro grafy-----------------------------------------
			if OwnCache[i].CArchived then Inc(Arc);
			//ShowMessage(OwnCache[i].CType);
			if not ((OwnCache[i].CType = 'Event Cache') or 
			   (OwnCache[i].CType = 'Cache In Trash Out Event') or
			   (OwnCache[i].CType = 'Lost and Found Event Cache') or
			   (OwnCache[i].CType = 'Mega-Event Cache'))
			then begin
				Inc(MyCaches);
				//ShowMessage('jedem:' + IntToStr(High(Logs)));
				//jen pro kee (Eventy se tu nee---------------------------------
				//FOUND-------------------------------------------------------------
				dcnt := 0; dcnt2 :=0;							//potadlo FOUND a NOTFOUND
				gg := False; ga := False;						//pomocn pro disabled a archive
				pomdate := ZeroDay;  							//Rok ped geocachingem
				// 0-lov bod FOUND
				Inc(GCount);									//+1
				SetLength(graf, GCount);						//pam + 1
				graf[GCount-1].Day := 0;						//poet dn max	(0)
				graf[GCount-1].Value := dcnt;					//posledn hodnota (0)
				graf[GCount-1].SS := True;
				//
				if LCount > 0 then begin
				  //XTime := Now;
				  For j := Low(Logs) to High(Logs) do begin
					if GeoBusyTest then BreakWork;
					//if Logs[j].LType <> 'Found it' then continue;
					//ShowHTMLMessage('test','initime = ' + FormatDateTime('dddddd', pomdate) + ' LogTime = ' + FormatDateTime('dddddd', Logs[j].LogDate));
					if pomdate < Logs[j].LogDate then begin
						//FOUND	
						Inc(GCount);							//+1
						SetLength(graf, GCount);				//pam + 1
						h1 := Trunc(Logs[j].LogDate - stime) + 1;
						graf[GCount-1].Day := h1;
						graf[GCount-1].Value := dcnt;
						graf[GCount-1].SS := True;
						graf[GCount-1].opt := True;
						if (GCount - 2 ) <> 0 then graf[GCount-2].Value := dcnt;
						//
						pomdate := Logs[j].LogDate;
					end;
					if Logs[j].LType = 'Found it' then begin
						dcnt := dcnt + 1;			//potm found
					end;
					//DISABLE
					if gg then begin
						if (DCount > 0 ) and
						   (disable[DCount-1].Day = (h1)) and
						   (disable[DCount-1].Value = FindValue(graf, h1)) and
						   (Logs[j].LType <> 'Enable Listing') then continue;
						//ShowHTMLMessage('test 1b','count = ' + IntToStr(DCount) + ' LogTime = ' + IntToStr(Trunc(Logs[j].LogDate - stime) + 1));
						Inc(DCount);
						SetLength(disable, DCount);						//pam + 1
						if h1 < 0 then
							disable[DCount-1].Day := 0
						else
							disable[DCount-1].Day := h1;
						disable[DCount-1].Value := FindValue(graf, h1);
						disable[DCount-1].SS := True;
						disable[DCount-1].opt := True;
						if Logs[j].LType = 'Enable Listing' then begin
							gg := False;
							disable[DCount-1].SS := False;
						end;
					end;
					if (not gg) and (Logs[j].LType = 'Temporarily Disable Listing') then begin
						//ShowHTMLMessage('test 1a','count = ' + IntToStr(DCount) + ' LogTime = ' + IntToStr(Trunc(Logs[j].LogDate - stime) + 1));
						Inc(DCount);
						SetLength(disable, DCount);						//pam + 1
						disable[DCount-1].Day := h1;
						disable[DCount-1].Value := FindValue(graf, h1);
						disable[DCount-1].SS := True;
						disable[DCount-1].opt := True;
						gg := True;
						//continue;
					end;
					//ARCHIVE
					if ga then begin
						if (ACount > 0 ) and
						   (archive[ACount-1].Day = (h1)) and
						   (archive[ACount-1].Value = FindValue(graf, h1)) and
						   (Logs[j].LType <> 'Unarchive') then continue;
						Inc(ACount);
						SetLength(archive, ACount);						//pam + 1
						if h1 < 0 then
							archive[ACount-1].Day := 0
						else
							archive[ACount-1].Day := h1;
						archive[ACount-1].Value := FindValue(graf, h1);
						archive[ACount-1].SS := True;
						archive[ACount-1].opt := True;
						if Logs[j].LType = 'Unarchive' then begin
							ga := False;
							IsArchive := -1;
							archive[ACount-1].SS := False;
						end;
					end;
					if (not ga) and (Logs[j].LType = 'Archive') then begin
						Inc(ACount);
						SetLength(archive, ACount);						//pam + 1
						archive[ACount-1].Day := h1;
						archive[ACount-1].Value := FindValue(graf, h1);
						archive[ACount-1].SS := True;
						archive[ACount-1].opt := True;
						IsArchive := archive[ACount-1].Day;
						ga := True;
						//continue;
					end;
				  end;
				end;
				//ShowMessage(FormatDateTime('hh:mm:ss.zzz',XTime - Now));
				// zvren bod FOUND--------------------------------------------------
				Inc(GCount);									//+1
				SetLength(graf, GCount);						//pam + 1
				if (IsArchive > 0) then
					graf[GCount-1].Day := h1					//posledn found log
				else
					graf[GCount-1].Day := OwnCache[i].CExist;	//poet dn max
				graf[GCount-1].Value := dcnt;					//posledn hodnota
				graf[GCount-1].SS := True;
				if (GCount - 2 ) <> 0 then graf[GCount-2].Value := dcnt;
				//----------------------------------------------------------------------
				//
				//doasn --> 
				//YEAR-----------------------------------------
				if MOSForm_chbYears.checked then begin
					DecodeDate(OwnCache[i].CDtPublic, myear, mmonth, mday);
					//MAXY
					For j:= Low(YearlyMax) to High(YearlyMax) do begin
						if YearlyMax[j].Year = myear then begin
							maxy := YearlyMax[j].MaxY;								//max Y pro YEARS
							break;
						end;
					end;
					//MAXX
					if myear > year then begin maxx := 0; year := myear; end;		//reset size X pro YEARS nov rok zan
				end
				else begin	//NO YEAR--------------------------
					if dcnt > maxy then maxy := dcnt;								//max Y
				end;
				//---------------------------------------------
				if OwnCache[i].CExist > maxx then maxx := OwnCache[i].CExist;		//max X
				//ShowMessage('Maxx: ' + IntToStr(maxx) + ' - ' + IntToStr(year));
				//zvr DISABLE
				if (gg) and (DCount > 0) then begin
					//ShowHTMLMessage('test 2','count = ' + IntToStr(DCount) + ' LogTime = ' + IntToStr(Trunc(Today - stime) + 1));
					Inc(DCount);
					SetLength(disable, DCount);						//pam + 1
					disable[DCount-1].Day := OwnCache[i].CExist; //Trunc(Today - stime) + 1;
					disable[DCount-1].Value := dcnt; //FindValue(graf, Trunc(Today - stime) + 1);
					disable[DCount-1].SS := False;
					disable[DCount-1].opt := True;
					IsDisable := True;
				end;
				//zvr ARCHIVE
				if (ga) and (ACount > 0) then begin
					Inc(ACount);
					SetLength(archive, ACount);								//pam + 1
					archive[ACount-1].Day := IsArchive;				 		//OwnCache[i].CExist; //Trunc(Today - stime) + 1;
					archive[ACount-1].Value := archive[ACount-2].Value; 	//dcnt; //FindValue(graf, Trunc(Today - stime) + 1);
					archive[ACount-1].SS := False;
					archive[ACount-1].opt := True;
				end;
				//if (IsArchive > 0) and (maxx > IsArchive) then maxx := IsArchive;
				//------------------------------------------------------------------
				//------------------------------------------------------------------
				//zporci----------------------------------------------------------
				//------------------------------------------------------------------
				//------------------------------------------------------------------
				For j := Low(graf) to High(graf) do begin
					if j > 0 then begin
						if graf[j].Day < 1 then begin
							graf[j].opt := False;
						end;
					end;
				end;
				//------------------------------------------------------------------
				//------------------------------------------------------------------
				//optimalizace hlavnho grafu---------------------------------------
				//------------------------------------------------------------------
				//------------------------------------------------------------------
				k := (OwnCache[i].CExist div GWidth) + 1;
				if ((OwnCache[i].CExist / k) > 150) then k := k * 2;
				n := (OwnCache[i].CFoundIt div GHeight)*2 + 1;
				//
				//ShowHTMLMessage('test','k = ' + IntToStr(k) + '/ n = ' + IntToStr(n) + ' width: ' + IntToStr(GWidth) + ' height: ' + IntToStr(GHeight) + ' CExist: ' + IntToStr(OwnCache[i].CExist) + ' CFoundIt: ' + IntToStr(OwnCache[i].CFoundIt));
				//XTime := Now;
				if (n>1) or (k>1) then begin 
					For j := Low(graf) to High(graf) do begin
					    if k >= n then begin
							//optimalizace asov (pro dlouhovk kee s menm pohybem)
							if not graf[j].opt then continue;
							if j < High(graf) then begin
								For m := j + 1 to High(graf) do begin
									if (graf[m].Day - graf[j].Day) < k then begin
										graf[m].opt := False;
									end
									else break;
								end;
							end;
						end
						else begin
							//optimalizace hodnotov (pro hodn frekventovan kee)
							if not graf[j].opt then continue;
							if j < High(graf) then begin
								For m := j + 1 to High(graf) do begin
									if (graf[m].Value - graf[j].Value) < n then begin
										graf[m].opt := False;
									end
									else break;
								end;
							end;
						end;
					end;
					graf[0].opt := True;					//prvn hodnota vdy OK
					graf[High(graf)].opt := True;			//posledn hodnota vdy OK
				end;
				//------------------------------------------------------------------
				//Odstran chybu s poslednm bodem pi archiv/unarchiv
				//------------------------------------------------------------------
				if (graf[High(graf)].Day < graf[High(graf)-1].Day) and (OwnCache[i].CArchived) then begin
					graf[High(graf)].opt := False;
					graf[High(graf)-1].opt := True;
				end; 
				//------------------------------------------------------------------
				//------------------------------------------------------------------
				//------------------------------------------------------------------
				//------------------------------------------------------------------
				//------------------------------------------------------------------
				//Language
				if MOSForm_cbLang.Items[MOSForm_cbLang.ItemIndex] = 'CZ' then
					UseLanguage('CS')
				else
					UseLanguage('EN');
				//------------------------------------------------------------------
				//HTML Cache
				//XTime := Now;
				gFound := ''; gNFound := ''; gDisable := ''; gArchive := ''; gColors := ''; gData := ''; gMarks := ''; gHints := '';
				dcnt := 0;
				//maxx := 1024; maxy := 210;
				//
				if GCount > 0 then begin
					st1 := ''; st2 := '';
					For j := Low(graf) to High(graf) do begin
						//if (IsArchive > 0) and (IsArchive < graf[j].Day) then continue;
						if graf[j].opt then begin
							st1 := st1 + IntToStr(graf[j].Day) + ',';
							st2 := st2 + IntToStr(graf[j].Value) + ',';
						end;
					end;
					gFound := Copy(st1,1,Length(st1)-1) + '|' + Copy(st2,1,Length(st2)-1);
					gData := gFound;
					gColors := GraphCacheEnabled + ',';							//Barva ry
					gMarks := 'B,' + GraphCacheEnabled + '80,0,0,0|';			//Barva vpln
					gHints := _('Found') + '|';
					Inc(dcnt);
				end;
				//
				//ShowMessage(IntToStr(DCount));
				if DCount > 0 then begin
					//ShowMessage(OwnCache[i].CName + ': ' + IntToStr(DCount));
					dcnt2 := 0; tmpval := -1; firstval := -1;
					st1 := ''; st2 := ''; st1x := ''; st2y := '';
					For j := Low(disable) to High(disable) do begin
						//Archivn
						if (IsArchive > 0) and (disable[j].Day > IsArchive) then h2 := IsArchive
						else h2 := disable[j].Day;
						//
						if (tmpval = disable[j].Value) and (disable[j].SS) then continue;
						if tmpval < 0 then begin
							//zatek (0)
							if h2 = 0 then st1 := st1 + '0,'
							else st1 := st1 + IntToStr(h2-1) + ',';
							st2 := st2 + '0,';
							//
							firstval := disable[j].Day;
						end;
						//
						if disable[j].Value <> tmpval then begin
							st1 := st1 + IntToStr(h2) + ',';
							st2 := st2 + IntToStr(disable[j].Value) + ','; 
							//
							tmpval := disable[j].Value;
						end;
						//
						if dcnt2 <> 0 then ddays := ddays + (h2 - dcnt2);
						dcnt2 := h2;
						//
						if not disable[j].SS then begin
							//posledn bod
							st1 := st1 + IntToStr(h2) + ',';
							st2 := st2 + IntToStr(disable[j].Value) + ',';
							//zakonen (0)
							st1 := st1 + IntToStr(h2+1) + ',';
							st2 := st2 + '0,';
							//
							ddays := ddays + (h2 - dcnt2);
							dcnt2 := 0;
							//
							//if OwnCache[i].CFoundIt > 2000 then m := (n div 2) else m := k;
							//ShowMessage('h1,h2 = ' + IntToStr(h2-firstval) + ' ' + IntToStr(m));
							if (h2-firstval) > k{m} then begin
								//ShowMessage('st1,st2' + CRLF + st1 + CRLF + CRLF + st2);
								st1x := st1x + st1;
								st2y := st2y + st2;
							end;
							//
							st1 := ''; st2 := ''; 
							tmpval := -1; firstval := -1;
						end;
					end;
					if Trim(st1x) <> '' then begin
						gData := gData + '|' + Copy(st1x,1,Length(st1x)-1) + '|' + Copy(st2y,1,Length(st2y)-1);
						gColors := gColors + GraphCacheDisabled + ',';										//Barva ry
						gMarks := gMarks + 'B,' + GraphCacheDisabled + ',' + IntToStr(dcnt) + ',0,0|';		//Barva vpln
						gHints := gHints + _('Disabled') + '|';
						Inc(dcnt);
					end;
				end;
				//
				if ACount > 0 then begin
					//ShowMessage(OwnCache[i].CName + ': ' + IntToStr(DCount));
					dcnt2 := 0; tmpval := -1; firstval := -1;
					st1 := ''; st2 := ''; st1x := ''; st2y := '';
					For j := Low(archive) to High(archive) do begin
						//Archivn
						if (IsArchive > 0) and (archive[j].Day > IsArchive) then h2 := IsArchive
						else h2 := archive[j].Day;
						//
						if (IsArchive > 0) and (IsArchive < archive[j].Day) then continue;
						if (tmpval = archive[j].Value) and (archive[j].SS) then continue;
						if tmpval < 0 then begin
							//zatek (0)
							if h2 = 0 then st1 := st1 + '0,'
							else st1 := st1 + IntToStr(h2-1) + ',';
							st2 := st2 + '0,';
							//
							firstval := archive[j].Day;
						end;
						//
						if archive[j].Value <> tmpval then begin
							st1 := st1 + IntToStr(h2) + ',';
							st2 := st2 + IntToStr(archive[j].Value) + ','; 
							//
							tmpval := archive[j].Value;
						end;
						//
						if dcnt2 <> 0 then adays := adays + (h2 - dcnt2);
						dcnt2 := h2;
						//
						if (IsArchive > 0) and (archive[j].Day = graf[High(graf)].Day) then begin
							//zakonceni (0) - pokud konec souhlas s archivem
							st1 := st1 + IntToStr(h2+1) + ',';
							st2 := st2 + '0,';
							//
							st1x := st1x + st1;
							st2y := st2y + st2;
							//
							break;
						end;
						//
						if not archive[j].SS then begin
							//posledn bod
							st1 := st1 + IntToStr(h2) + ',';
							st2 := st2 + IntToStr(archive[j].Value) + ',';
							//
							if (IsArchive > 0) and (archive[j].Day < graf[High(graf)].Day) then begin
								h2 := graf[High(graf)].Day
								//dopotn archivu
								st1 := st1 + IntToStr(h2) + ',';
								st2 := st2 + IntToStr(graf[High(graf)].Value) + ',';
								if dcnt2 <> 0 then 
									adays := adays + (h2 - dcnt2)
								else
									adays := adays + (h2 - archive[j].Day);
							end else begin
								h2 := archive[j].Day
								adays := adays + (h2 - dcnt2);
							end;
							dcnt2 := 0;
							//zakonen (0)
							st1 := st1 + IntToStr(h2+1) + ',';
							st2 := st2 + '0,';
							//
							//if OwnCache[i].CFoundIt > 2000 then m := (n div 2) else m := k;
							//ShowMessage('h1,h2 = ' + IntToStr(h2-firstval) + ' ' + IntToStr(m));
							if (h2-firstval) > k{m} then begin
								//ShowMessage('st1,st2' + CRLF + st1 + CRLF + CRLF + st2);
								st1x := st1x + st1;
								st2y := st2y + st2;
							end;
							//
							st1 := ''; st2 := ''; 
							tmpval := -1; firstval := -1;
						end;
					end;
					if Trim(st1x) <> '' then begin
						gData := gData + '|' + Copy(st1x,1,Length(st1x)-1) + '|' + Copy(st2y,1,Length(st2y)-1);
						gColors := gColors + GraphCacheArchived + ',';										//Barva ry
						gMarks := gMarks + 'B,' + GraphCacheArchived + ',' + IntToStr(dcnt) + ',0,0|';		//Barva vpln
						gHints := gHints + _('Archive') + '|';
						Inc(dcnt);
					end;
				end;
				//
				//ShowMessage(FormatDateTime('hh:mm:ss.zzz',XTime - Now));
				//
				if Length(gColors) > 1 then gColors := Copy(gColors,1,Length(gColors)-1);
				gMarks := Copy(gMarks,1,Length(gMarks)-1);
				for j := 1 to dcnt do gGraphs := gGraphs + '0,%maxx%,0,%maxy%,';
				gGraphs := Copy(gGraphs,1,Length(gGraphs)-1);
				gHints := Copy(gHints,1,Length(gHints)-1);
				//----------------------------------------------------------------------------------
				lostdays := ddays { + adays};
				try
					efectreal := (LFo * 1.00) / (OwnCache[i].CExist - lostdays - 1.00);		//efektivita za celou ivotnost bez vpadk
				except
					efectreal := 0;
				end;
				//----------------------------------------------------------------------------------
				if efectreal <= 0.5 then succolor := gcolor[13]
				else if (efectreal <= 1) and (efectreal > 0.5) then succolor := gcolor[12]
				else succolor := gcolor[11];
				//YEAR-HEADER-----------------------------------------------------------------------
				if MOSForm_chbYears.checked then begin
					if not OwnCache[i].CArchived then begin
						DecodeDate(OwnCache[i].CDtPublic, myear, mmonth, mday);
						if myear > nyear then begin 
							nyear := myear;
							otxt := otxt + '<div class="MOS_year_head_main" align="center" style="margin-bottom:2px;">';
							otxt := otxt + '<div class="MOS_year_head" align="center" style="padding-top:5px; padding-bottom:5px; font-weight:bold; font-size:20px; color:#' + gcolor[12] +'; width:' + IntToStr(pgwidth) + 'px; background-color:#' + gcolor[3] + ';">----= ' + IntToStr(nyear) + ' =----</div>';
							otxt := otxt + '</div>';
						end;
					end;
				end;
				//----------------------------------------------------------------------------------
				//----------------------------------------------------------------------------------
				//Cache-Header----------------------------------------------------------------------
				//----------------------------------------------------------------------------------
				if OwnCache[i].CArchived then
					otxt := otxt + '<div class="MOS_cache" align="center" style="display: none;" id="MyOwnArc' + IntToStr(Arc) + '">'
				else
					otxt := otxt + '<div class="MOS_cache" align="center">';
				//				
				case MOSForm_cbHeaderSize.Items[MOSForm_cbHeaderSize.ItemIndex] of
					'S': begin
						otxt := otxt + '<div class="MOS_name_S" style="width:' + IntToStr(pgwidth) + 'px; background-color:#' + gcolor[7] + ';">';
						otxt := otxt + '<div class="MOS_name_1" style="margin-bottom:2px; font-weight:bold; vertical-align:middle; font-family:arial,sans-serif;"><img src="' + TypeUrl + 'sm/' + cachetype +'" style="margin-right:10px;vertical-align:middle;" /><a href="' + CacheURL + OwnCache[i].CGuid + '" target="_blank">' + OwnCache[i].ID + '</a> - ';
					end;
					'M': begin
						otxt := otxt + '<div class="MOS_name_M" style="width:' + IntToStr(pgwidth) + 'px; background-color:#' + gcolor[7] + ';">';
						otxt := otxt + '<div class="MOS_name_1" style="margin-bottom:2px; font-weight:bold; vertical-align:middle; font-family:arial,sans-serif; font-size:18px;"><img src="' + TypeUrl + 'sm/' + cachetype +'" style="margin-right:10px;vertical-align:middle;" /><a href="' + CacheURL + OwnCache[i].CGuid + '" target="_blank">' + OwnCache[i].ID + '</a> - ';
					end;
					'L': begin
						otxt := otxt + '<div class="MOS_name_L" style="width:' + IntToStr(pgwidth) + 'px; background-color:#' + gcolor[7] + ';">';
						otxt := otxt + '<div class="MOS_name_1" style="margin-bottom:2px; font-weight:bold; vertical-align:middle; font-family:arial,sans-serif; font-size:20px;"><img src="' + TypeUrl + cachetype +'" style="margin-right:10px;vertical-align:middle;" /><a href="' + CacheURL + OwnCache[i].CGuid + '" target="_blank">' + OwnCache[i].ID + '</a> - ';
					end;
				end;
				//----------------------------------------------------------------------------------
				if OwnCache[i].CArchived then
					otxt := otxt + '<span class="MOS_archive" style="text-decoration:line-through; color: red;">' + myAnsiToUtf(OwnCache[i].CName) + '</span>'
				else if IsDisable then
					otxt := otxt + '<span class="MOS_disable" style="text-decoration:line-through; color: #' + gcolor[8] + ';">' + myAnsiToUtf(OwnCache[i].CName) + '</span>'	
				else
					otxt := otxt + '<span class="MOS_normal" style="color: #' + gcolor[8] + ';">' + myAnsiToUtf(OwnCache[i].CName) + '</span>';
				otxt := otxt + '</div>' + CRLF;
				//----------------------------------------------------------------------------------
				otxt := otxt + '<div class="MOS_name_2" style="margin-bottom:8px;">';
				otxt := otxt + '<b>' + _('Size') + ': </b><img src="' + ContainerURL + Size + '" title="' + OwnCache[i].CSize + '" style="margin-right:5px;">';
				otxt := otxt + '<b>' + _('Difficulty') + ': </b><img src="' + StarURL + Difficult + '" title="' + OwnCache[i].CDifficult + '" style="margin-right:5px;">';
				otxt := otxt + '<b>' + _('Terrain') + ': </b><img src="' + StarURL + Terrain + '" title="' + OwnCache[i].CTerrain + '" style="margin-right:5px;">';
				if StrToInt(OwnCache[i].CElevation) > 0 then
					otxt := otxt + '<b>' + _('Elevation') + ':</b> ' + OwnCache[i].CElevation +  ' ' + _('m.a.s.l');
				otxt := otxt + '</div></div>' + CRLF;
				//----------------------------------------------------------------------------------
				//Info-blok-------------------------------------------------------------------------
				//----------------------------------------------------------------------------------
				otxt := otxt + '<div class="MOS_cache_info" align="left" style="width:' + IntToStr(pgwidth) + 'px; margin-bottom:20px;">';
				//----------------------------------------------------------------------------------
				//Graf------------------------------------------------------------------------------
				//----------------------------------------------------------------------------------
				otxt := otxt + '<div class="MOS_graph_complete" style="display:inline-block; max-width:' + IntToStr(GWidth) + ';">';
				otxt := otxt + '<img src="http://chart.apis.google.com/chart?chxr=0,0,%maxy%|1,0,%maxx%';
				otxt := otxt + '&chf=bg,s,' + gcolor[1] + '|c,ls,90,' + gcolor[13] + '80,0.044,' + gcolor[1] + ',0.044';
				otxt := otxt + '&chxs=0,676767,11.5,1,lt,676767|1,676767,11.5,1,lt,676767&chxt=y,x&chs=' + IntToStr(GWidth) + 'x' + IntToStr(GHeight) + '&cht=lxy&chco=' + gColors;
				otxt := otxt + '&chds=' + gGraphs;
				otxt := otxt + '&chd=t:' + gData; 
				//outtxt := outtxt + '&chdl=' + gHints + '&chdlp=t&chg=100,50,3,3&chls=2|2|1';
				otxt := otxt + '&chdl=' + gHints + '&chdlp=t&chls=2|2|1';
				otxt := otxt + '&chm=' + gMarks + '"';
				otxt := otxt + ' width="' + IntToStr(GWidth) + '" height="' + IntToStr(GHeight) + '" alt="" style="margin-bottom:4px;"/>' + CRLF;
				//----------------------------------------------------------------------------------
				//Pod grafem------------------------------------------------------------------------
				//----------------------------------------------------------------------------------
				//Found
				otxt := otxt + '<div class="MOS_under_graph" align="center"><img src="' + StatusURL + 'icon_smile.gif" title="' + _('Found') + '" style="margin-left:3px;vertical-align: middle;"> ' + IntToStr(LFo);
				//NotFound
				if LNf > 0 then otxt := otxt + '<img src="' + StatusURL + 'icon_sad.gif" title="' + _('Not found') + '" style="margin-left:3px;vertical-align: middle;"> ' + IntToStr(LNf);
				//Disabled
				if ddays > 0 then otxt := otxt + '<img src="'+ StatusURL + 'icon_disabled.gif" title="' + _('Disabled') + ' (' + IntToStr(ddays) + ' ' + _('days') + ')" style="margin-left:3px;vertical-align: middle;"> ' + IntToStr(Dis);
				//Archived
				if (adays > 0) or (IsArchive > 0) then begin
					if (adays > 0) then
						otxt := otxt + '<img src="'+ StatusURL + 'traffic_cone.gif" title="' + _('Archived') + ' (' + IntToStr(adays) + ' ' + _('days') + ')" style="margin-left:3px;vertical-align: middle;"> ' + IntToStr(Arch)
					else
						otxt := otxt + '<img src="'+ StatusURL + 'traffic_cone.gif" title="' + _('Archived') + '" style="margin-left:3px;vertical-align: middle;"> ' + IntToStr(Arch);
				end;
				if MOSForm_chbFP.checked then begin
				//Favorites point
					if OwnCache[i].FP > 0 then otxt := otxt + '<img src="' + StatusURL + 'icon_fav.png" title="' + _('Favorite points') + '" style="margin-left:3px;vertical-align: middle;"> ' + IntToStr(OwnCache[i].FP);
				end;
				if MOSForm_chbGCVote.checked then begin
				//GCVote
					if not((OwnCache[i].GCMedian = 0) or (GCStar = '')) then
						otxt := otxt + '<img src="'+ StarURL + GCStar + '" title="' + _('GC-Vote:') + ' ' + FlToStr(OwnCache[i].GCMedian) + '" style="margin-left:3px;vertical-align: middle;"> ' + OwnCache[i].GCCount;
				end;
				if MOSForm_chbCzechVote.checked then begin
				//CZVote
					if not((OwnCache[i].CZVote = 0) or (CZStar = '')) then
						otxt := otxt + '<img src="'+ StarURL + CZStar + '" title="' + _('CZ-Vote:') + ' ' + OwnCache[i].CZVoteStr + '" style="margin-left:3px;vertical-align: middle;"> ' + OwnCache[i].CZCount;
				end;
				otxt := otxt + '</div></div>' + CRLF;
				//----------------------------------------------------------------------------------
				//Text-info-vedle-grafu-------------------------------------------------------------
				//----------------------------------------------------------------------------------
				otxt := otxt + '<div class="MOS_right_panel" align="left" style="display:inline-block; vertical-align:top; max-width:' + IntToStr(txwidth-1) + 'px; font-family:arial,sans-serif;">';
				if pubyes then begin
					//Cache success
					if lostdays > 0 then
						otxt := otxt + '<img src="'+ OtherURL + 'check.gif" title="' + _('Success') + '" style="margin-left:5px;"><span class="MOS_centertext" style="vertical-align:middle"> <b>' + _('Cache Success') + ': <span class="MOS_efectreal" style="padding-left:5px; padding-right:5px; border: 3px solid #' + succolor + ';">' + flToStr(Round(efectreal*1000.00) / 1000.00) + '</span></b> (' + flToStr(Round(efectivity*1000.00) / 1000.00) + ') ' + _('founds/day') + '</span><br/>'
					else
						otxt := otxt + '<img src="'+ OtherURL + 'check.gif" title="' + _('Success') + '" style="margin-left:5px;"><span class="MOS_centertext" style="vertical-align:middle"> <b>' + _('Cache Success') + ': <span  class="MOS_efectreal" style="padding-left:5px; padding-right:5px; border: 3px solid #' + succolor + ';">' + flToStr(Round(efectivity*1000.00) / 1000.00) + '</span></b> ' + _('founds/day') + '</span><br/>';
					//Public date
					otxt := otxt + '<img src="'+ StatusURL + 'icon_greenlight.gif" title="' + _('Published') + ': (' + Reviewer +  ')" style="margin-left:5px;"><span class="MOS_centertext" style="vertical-align:middle"> <b>' + _('Published') + ': </b>' + FormatDateTime('d". "m". "yyyy', OwnCache[i].CDtPublic);
					//Create
					if OwnCache[i].CDtPublic <> OwnCache[i].CHDatum then
						otxt := otxt + ' (' + FormatDateTime('d". "m". "yyyy', OwnCache[i].CHDatum) + ')';
					otxt := otxt + '</span><br/>';	
					//Last found date
					//
					if LastFound = ZeroDay then
						otxt := otxt + '<img src="' + StatusURL + 'icon_smile.gif" title="' + _('Last found') + ': (' + _('Not found') + ')" style="margin-left:5px;"><span class="MOS_centertext" style="vertical-align:middle"> <b>' + _('Last found') + ': </b>- ' + _('Not found') + ' -</span><br/>'
					else
						otxt := otxt + '<img src="' + StatusURL + 'icon_smile.gif" title="' + _('Last found') + ': (' + myAnsiToUtf(LastFinder) + ')" style="margin-left:5px;"><span class="MOS_centertext" style="vertical-align:middle"> <b>' + _('Last found') + ': </b>' + FormatDateTime('d". "m". "yyyy', LastFound) + '</span><br/>';
					//Days exist
					//
					if OwnCache[i].CExist = exist then
						otxt := otxt + '<img src="'+ OtherURL + 'book_open_mark.gif" title="' + _('Days exist') + '" style="margin-left:5px;"><span class="MOS_centertext" style="vertical-align:middle"> <b>' + _('Days exist') + ':</b> ' + IntToStr(OwnCache[i].CExist - 1) + '</span><br/>'
					else
						otxt := otxt + '<img src="'+ OtherURL + 'book_open_mark.gif" title="' + _('Days exist') + '" style="margin-left:5px;"><span class="MOS_centertext" style="vertical-align:middle"> <b>' + _('Days exist') + ':</b> ' + IntToStr(OwnCache[i].CExist - 1) + ' (' + IntToStr(exist - 1) + ')</span><br/>';
					//Logy
					//
					otxt := otxt + '<img src="'+ OtherURL + 'comment_add.gif" title="' + _('Logs') + '" style="margin-left:5px;"><span class="MOS_centertext" style="vertical-align:middle"> <b>' + _('Logs') + ': </b>' + IntToStr(LCount);
					if MOSForm_chbWord.checked then
						otxt := otxt + ' <b>' + _('Average log') + ': </b>' + IntToStr(round((CountW * 1.0)/LCount)) + ' ' + _('words');
						TotalWords := TotalWords + round((CountW * 1.0)/LCount);
					otxt := otxt + '</span><br/>';
					//xTF
					if MOSForm_chbXTF.checked then begin
						//otxt := otxt + '<br />';
						//
						//FTF
						if OwnCache[i].CFTF <> '' then 
							otxt := otxt + '<img src="'+ AwardURL + 'award_star_gold_3.png" title="' + _('Gold') + ' - ' + myAnsiToUtf(OwnCache[i].CFTF) + '" style="margin-left:5px;"><span class="MOS_centertext" style="vertical-align:middle"> <b>' + _('FTF') + ': </b>' + myAnsiToUtf(Copy(OwnCache[i].CFTF,1,50 + ((pgwidth - 720) div 10))) + '</span><br/>';
						//STF
						if OwnCache[i].CSTF <> '' then 
							otxt := otxt + '<img src="'+ AwardURL + 'award_star_silver_3.png" title="' + _('Silver') + ' - ' + myAnsiToUtf(OwnCache[i].CSTF) + '" style="margin-left:5px;"><span class="MOS_centertext" style="vertical-align:middle"> <b>' + _('STF') + ': </b>' + myAnsiToUtf(Copy(OwnCache[i].CSTF,1,50 + ((pgwidth - 720) div 10))) + '</span><br/>';
						//TTF
						if OwnCache[i].CTTF <> '' then 
							otxt := otxt + '<img src="'+ AwardURL + 'award_star_bronze_3.png" title="' + _('Bronze') + ' - ' + myAnsiToUtf(OwnCache[i].CTTF) + '" style="margin-left:5px;"><span class="MOS_centertext" style="vertical-align:middle"> <b>' + _('TTF') + ': </b>' + myAnsiToUtf(Copy(OwnCache[i].CTTF,1,50 + ((pgwidth - 720) div 10))) + '</span><br/>';
					end;
				end
				else begin
					Reviewer := _('Didn''t found publication log');
					otxt := otxt + '<img src="'+ LogTypesURL + '45.png" title="' + _('Data problem') + ': (' + Reviewer +  ')" style="margin-left:5px;"><span class="MOS_centertext" style="vertical-align:middle"> <b>' + Reviewer + ': </b>' + _('It is necessary to correctly import logs into GeoGet database!');
					//Create
					if OwnCache[i].CDtPublic <> OwnCache[i].CHDatum then
						otxt := otxt + ' (' + FormatDateTime('d". "m". "yyyy', OwnCache[i].CHDatum) + ')';
					otxt := otxt + '</span><br/>';
					list.Add(OwnCache[i].ID);
				end;
				otxt := otxt + '</div></div></div>' + CRLF;
				//YEAR
				if MOSForm_chbYears.checked then begin
					otxt := ReplaceString(otxt, '%maxx%', IntToStr(maxx));
					otxt := ReplaceString(otxt, '%maxy%', IntToStr(maxy));
				end;
				//----
				if OwnCache[i].CArchived then
				  caouttxt := caouttxt + otxt
				else
				  couttxt := couttxt + otxt;
			end
			else begin
				//----------------------------------------------------------------------------------
				//HTML Event-Header-----------------------------------------------------------------
				//----------------------------------------------------------------------------------
				Inc(MyEvents);
				if OwnCache[i].CArchived then
					otxt := otxt + '<div class="MOS_event" align="center" style="margin-bottom:20px; display: none;" id="MyOwnArc' + IntToStr(Arc) + '">'
				else
					otxt := otxt + '<div class="MOS_event" align="center" style="margin-bottom:20px;">';
				//
				case MOSForm_cbHeaderSize.Items[MOSForm_cbHeaderSize.ItemIndex] of
					'S': begin
						otxt := otxt + '<div class="MOS_name_S" style="width:' + IntToStr(pgwidth) + 'px; background-color:#' + gcolor[7] + ';">';
						otxt := otxt + '<div class="MOS_name_1" style="margin-bottom:2px; font-weight:bold; vertical-align:middle; font-family:arial,sans-serif;"><img src="' + TypeUrl + 'sm/' + cachetype +'" style="margin-right:10px;vertical-align:middle;" /><a href="' + CacheURL + OwnCache[i].CGuid + '" target="_blank">' + OwnCache[i].ID + '</a> - ';
					end;
					'M': begin
						otxt := otxt + '<div class="MOS_name_M" style="width:' + IntToStr(pgwidth) + 'px; background-color:#' + gcolor[7] + ';">';
						otxt := otxt + '<div class="MOS_name_1" style="margin-bottom:2px; font-weight:bold; vertical-align:middle; font-family:arial,sans-serif; font-size:18px;"><img src="' + TypeUrl + 'sm/' + cachetype +'" style="margin-right:10px;vertical-align:middle;" /><a href="' + CacheURL + OwnCache[i].CGuid + '" target="_blank">' + OwnCache[i].ID + '</a> - ';
					end;
					'L': begin
						otxt := otxt + '<div class="MOS_name_L" style="width:' + IntToStr(pgwidth) + 'px; background-color:#' + gcolor[7] + ';">';
						otxt := otxt + '<div class="MOS_name_1" style="margin-bottom:2px; font-weight:bold; vertical-align:middle; font-family:arial,sans-serif; font-size:20px;"><img src="' + TypeUrl + cachetype +'" style="margin-right:10px;vertical-align:middle;" /><a href="' + CacheURL + OwnCache[i].CGuid + '" target="_blank">' + OwnCache[i].ID + '</a> - ';
					end;
				end;
				//----------------------------------------------------------------------------------
				if OwnCache[i].CStatus = 2 then begin
					otxt := otxt + '<span class="MOS_archive" style="text-decoration:line-through; color: red;">' + myAnsiToUtf(OwnCache[i].CName) + '</span>';
					Inc(MyAEvents);
				end
				else if OwnCache[i].CStatus = 1 then
					otxt := otxt + '<span class="MOS_disable" style="text-decoration:line-through; color: #' + gcolor[8] + ';">' + myAnsiToUtf(OwnCache[i].CName) + '</span>'	
				else
					otxt := otxt + '<span class="MOS_normal" style="color: #' + gcolor[8] + ';">' + myAnsiToUtf(OwnCache[i].CName) + '</span>';
				otxt := otxt + '</div>' + CRLF;
				//----------------------------------------------------------------------------------
				otxt := otxt + '<div class="MOS_name_2" style="margin-bottom:8px;">';
				otxt := otxt + '<b>' + _('Size') + ': </b><img src="' + ContainerURL + Size + '" title="' + OwnCache[i].CSize + '" style="margin-right:5px;">';
				otxt := otxt + '<b>' + _('Difficulty') + ': </b><img src="' + StarURL + Difficult + '" title="' + OwnCache[i].CDifficult + '" style="margin-right:5px;">';
				otxt := otxt + '<b>' + _('Terrain') + ': </b><img src="' + StarURL + Terrain + '" title="' + OwnCache[i].CTerrain + '" style="margin-right:5px;">';
				if StrToInt(OwnCache[i].CElevation) > 0 then
					otxt := otxt + '<b>' + _('Elevation') + ':</b> ' + OwnCache[i].CElevation +  ' ' + _('m.a.s.l');
				otxt := otxt + '</div></div>';
				//
				//----------------------------------------------------------------------------------
				//Text info-------------------------------------------------------------------------
				//----------------------------------------------------------------------------------
				otxt := otxt + '<div class="MOS_event_info" align="center" style="vertical-align:top; font-family:arial,sans-serif;">';
				//Public date
				if pubyes then begin
					otxt := otxt + '<div class="MOS_event_publish" align="center"><img src="'+ StatusURL + 'icon_greenlight.gif" title="' + _('Published') + ': (' + Reviewer +  ')">   <b>' + _('Published') + ': </b>' + FormatDateTime('d". "m". "yyyy', OwnCache[i].CDtPublic);
					//Create date
					if OwnCache[i].CDtPublic <> OwnCache[i].CHDatum then
						otxt := otxt + ' (' + FormatDateTime('dd". "mm". "yyyy', OwnCache[i].CHDatum) + ')';
				end
				else begin
					Reviewer := _('Didn''t found publication log');
					otxt := otxt + '<div class="MOS_event_publish" align="center"><img src="'+ LogTypesURL + '45.png" title="' + _('Data problem') + ': (' + Reviewer +  ')">  <b>' + Reviewer + ': </b>' + _('It is necessary to correctly import logs into GeoGet database!');
					//Create
					if OwnCache[i].CDtPublic <> OwnCache[i].CHDatum then
						otxt := otxt + ' (' + FormatDateTime('d". "m". "yyyy', OwnCache[i].CHDatum) + ')';
					list.Add(OwnCache[i].ID);
				end;
				otxt := otxt  + '</div>';
				//----------------------------------------------------------------------------------
				otxt := otxt  + '<div class="MOS_event_info_other" align="center">';
				//Will attend
				otxt := otxt + '<img src="' + StatusURL + 'icon_rsvp.gif" title="' + _('Will attend') + '" style="margin-left:3px;vertical-align: middle;"> ' + IntToStr(WA);
				//Attended
				otxt := otxt + '<img src="' + StatusURL + 'icon_attended.gif" title="' + _('Attended') + '" style="margin-left:3px;vertical-align: middle;"> ' + IntToStr(LFo);
				//Archived
				if Arch > 0 then
					otxt := otxt + '<img src="' + StatusURL + 'traffic_cone.gif" title="' + _('Archived') + '" style="margin-left:3px;vertical-align: middle;"> 1';
				if MOSForm_chbGCVote.checked then begin
					//GCVote
					if not((OwnCache[i].GCMedian = 0) or (GCStar = '')) then
						otxt := otxt + '<img src="'+ StarURL + GCStar + '" title="' + _('GC-Vote:') + ' ' + FlToStr(OwnCache[i].GCMedian) + '" style="margin-left:3px;vertical-align: middle;"> ' + OwnCache[i].GCCount;
				end;
				if MOSForm_chbCzechVote.checked then begin
					//CZVote
					if not((OwnCache[i].CZVote = 0) or (CZStar = '')) then
						otxt := otxt + '<img src="'+ StarURL + CZStar + '" title="' + _('CZ-Vote:') + ' ' + OwnCache[i].CZVoteStr + '" style="margin-left:3px;vertical-align: middle;"> ' + OwnCache[i].CZCount;
				end;
				otxt := otxt + '</div></div></div>' + CRLF;
				//YEAR
				if MOSForm_chbYears.checked then begin
					otxt := ReplaceString(otxt, '%maxx%', IntToStr(maxx));
					otxt := ReplaceString(otxt, '%maxy%', IntToStr(maxy));
				end;
				//----
				if OwnCache[i].CArchived then
				  eaouttxt := eaouttxt + otxt
				else
				  eouttxt := eouttxt + otxt;
			end;
			//ShowMessage(FormatDateTime('hh:mm:ss.zzz',XTime - Now));
		end;
		////ShowMessage(FormatDateTime('hh:mm:ss.zzz',XTime - Now));
		//Language
		TotalDays := DlyCnt;
		//ShowMessage('poet dn: ' + IntToStr(DlyCnt));
		//Statistic---------------------------------------------------------------------------------
		Caches := MyCaches + MyEvents;
		Aperc := Round((Arc * 100.000 / Caches)*100.00)/100.00;
		//ShowMessage('proc: ' + FlToStr(Arc * 100.000 / Caches));
		statxt := '';
		statxt := statxt + '<div class="MOS_stat_main" align="center">' + CRLF;
		statxt := statxt + '<div class="MOS_stat_h1" style="background-color: #' + gcolor[2] + '; width: ' + IntToStr(pgwidth) + 'px; font-weight: bold; color: #' + gcolor[10] + '; line-height: 20px; font-size: 13px; text-align: center;">' + _('Owned caches mini statistics') + '</div>' + CRLF;
		//		
		statxt := statxt + '<table class="MOS_stat_table" width="' + IntToStr(pgwidth) + 'px" cellpadding="0" border="0" style="font-size: 11px;">' + CRLF;
		//
		statxt := statxt + '<tr>'  + CRLF;
		statxt := statxt + '<td width="35%" style="background-color: #' + gcolor[5] + '; color: #' + gcolor[8] + ';">' + _('Owned:') + '</td>' + CRLF;
		statxt := statxt + '<td style="background-color: #' + gcolor[6] + '; color: #' + gcolor[8] + ';"><b>' + IntToStr(Caches) + '</b>, ' + IntToStr(Arc) + ' ' + _('now archived') + ' (' + FlToStr(Aperc) + '%), ' + _('Caches:') + ' ' + IntToStr(MyCaches) + ', ' + _('Events:') + ' ' + IntToStr(MyEvents) + '</td>' + CRLF;		
		statxt := statxt + '</tr>' + CRLF;
		//
		statxt := statxt + '<tr>'  + CRLF;
		statxt := statxt + '<td width="35%" style="background-color: #' + gcolor[5] + '; color: #' + gcolor[8] + ';">' + _('Total finds of my caches:') + '</td>' + CRLF;
		statxt := statxt + '<td style="background-color: #' + gcolor[6] + '; color: #' + gcolor[8] + ';"><b>' + IntToStr(TotalFound) + '</b> ' + _('finds in') + ' <b>' + IntToStr(TotalDays) + '</b> ' + _('total days') + ' <b></td>' + CRLF;
		statxt := statxt + '</tr>' + CRLF;
		//
		statxt := statxt + '<tr>'  + CRLF;
		statxt := statxt + '<td width="35%" style="background-color: #' + gcolor[5] + '; color: #' + gcolor[8] + ';">' + _('Total finds I''ve made:') + '</td>' + CRLF;
		statxt := statxt + '<td style="background-color: #' + gcolor[6] + '; color: #' + gcolor[8] + ';"><b>' + IntToStr(CacheFound) + '</b></td>' + CRLF;
		statxt := statxt + '</tr>' + CRLF;
		//
		statxt := statxt + '<tr>'  + CRLF;
		statxt := statxt + '<td width="35%" style="background-color: #' + gcolor[5] + '; color: #' + gcolor[8] + ';">' + _('Caching karma:') + '</td>' + CRLF;
		statxt := statxt + '<td style="background-color: #' + gcolor[6] + '; color: #' + gcolor[8] + ';"><b>' + FlToStr(Round((TotalFound / (CacheFound * 1.00))*100.00)/100.00) + '</b> (' + IntToStr(TotalFound) + '/' + IntToStr(CacheFound) + ')</td>' + CRLF;
		statxt := statxt + '</tr>' + CRLF;
		//
		statxt := statxt + '<tr>'  + CRLF;
		statxt := statxt + '<td width="35%" style="background-color: #' + gcolor[5] + '; color: #' + gcolor[8] + ';">' + _('Hide with the most finds:') + '</td>' + CRLF;
		statxt := statxt + '<td style="background-color: #' + gcolor[6] + '; color: #' + gcolor[8] + ';"><b>' + IntToStr(MostFound) + '</b>, ' + OwnCache[MostFCache].CName + ', <a href="' + CacheURL + OwnCache[MostFCache].CGuid + '" target="_blank">' + OwnCache[MostFCache].ID + '</a></td>' + CRLF;
		statxt := statxt + '</tr>' + CRLF;
		//
		statxt := statxt + '<tr>'  + CRLF;
		statxt := statxt + '<td width="35%" style="background-color: #' + gcolor[5] + '; color: #' + gcolor[8] + ';">' + _('Hide found most frequently:') + '</td>' + CRLF;
		statxt := statxt + '<td style="background-color: #' + gcolor[6] + '; color: #' + gcolor[8] + ';">' + _('Every') + ' <b>' + FlToStr(Round((1/MostFrq) * 100.00)/100.00) + '</b> ' + _('days,') +  ' ' + OwnCache[MostFrqCache].CName + ', <a href="' + CacheURL + OwnCache[MostFrqCache].CGuid + '" target="_blank">' + OwnCache[MostFrqCache].ID + '</a></td>' + CRLF;
		statxt := statxt + '</tr>' + CRLF;
		//
		if MOSForm_chbFP.checked then begin
			statxt := statxt + '<tr>'  + CRLF;
			statxt := statxt + '<td width="35%" style="background-color: #' + gcolor[5] + '; color: #' + gcolor[8] + ';">' + _('Hide with the most favorite points:') + '</td>' + CRLF;
			statxt := statxt + '<td style="background-color: #' + gcolor[6] + '; color: #' + gcolor[8] + ';"><b>' + IntToStr(MostFP) + '</b>, ' + OwnCache[MostFPCache].CName + ', <a href="' + CacheURL + OwnCache[MostFPCache].CGuid + '" target="_blank">' + OwnCache[MostFPCache].ID + '</a></td>' + CRLF;
			statxt := statxt + '</tr>' + CRLF;
			//
			statxt := statxt + '<tr>'  + CRLF;
			statxt := statxt + '<td width="35%" style="background-color: #' + gcolor[5] + '; color: #' + gcolor[8] + ';">' + _('Total favorite points received:') + '</td>' + CRLF;
			statxt := statxt + '<td style="background-color: #' + gcolor[6] + '; color: #' + gcolor[8] + ';"><b>' + IntToStr(TotalFP) + '</b></td>' + CRLF;
			statxt := statxt + '</tr>' + CRLF;
		end;
		//
		if MOSForm_chbWord.checked then begin 
			statxt := statxt + '<tr>'  + CRLF;
			statxt := statxt + '<td width="35%" style="background-color: #' + gcolor[5] + '; color: #' + gcolor[8] + ';">' + _('Log length, words:') + '</td>' + CRLF;
			statxt := statxt + '<td style="background-color: #' + gcolor[6] + '; color: #' + gcolor[8] + ';">' + _('Average:') + ' <b>' + IntToStr(Round(TotalWords/MyCaches)) + '</b>, ' + _('Longest:') + ' <a href="' + CacheURL + OwnCache[MostLLCache].CGuid + '" target="_blank">' + OwnCache[MostLLCache].ID + '</a> <b>' + IntToStr(MostLogLength) + '</b></td>' + CRLF;
			statxt := statxt + '</tr>' + CRLF;
		end;
		//
		statxt := statxt + '</table>' + CRLF;
		statxt := statxt + '</div></br>';
		//
		if not MOSForm_chbYears.checked then begin
			statxt := statxt + '<div class="MOS_after_stat_header" align="center">' + CRLF;
			statxt := statxt + '<div style="background-color: #' + gcolor[3] + '; width: ' + IntToStr(pgwidth) + 'px; font-weight: bold; color: #' + gcolor[4] + '; line-height: 20px; font-size: 13px; text-align: center;">' + _('Caches / Events') + '</div>' + CRLF;
			statxt := statxt + '</div></br>' + CRLF;
		end;
		//------------------------------------------------------------------------------------------
		if MOSForm_chbYears.checked then begin
			ehtxt := ehtxt + '<div class="MOS_year_ehead_main" align="center" style="margin-bottom:2px;">';
			ehtxt := ehtxt + '<div class="MOS_year_ehead" align="center" style="padding-top:5px; padding-bottom:5px; font-weight:bold; font-size:24px; width:' + IntToStr(pgwidth) + 'px; background-color: #' + gcolor[3] + ';">' + _('Events') + '</div>';
			ehtxt := ehtxt + '</div>';
		end;
		//
		if MOSForm_chbYears.checked then begin
			eahtxt := eahtxt + '<div class="MOS_year_ehead_main" align="center" style="margin-bottom:2px; display: none;" id="MyOwnArc' + IntToStr(Arc) + '"">';
			eahtxt := eahtxt + '<div class="MOS_year_ehead" align="center" style="padding-top:5px; padding-bottom:5px; font-weight:bold; font-size:24px; width:' + IntToStr(pgwidth) + 'px; background-color: #' + gcolor[3] + ';">' + _('Events') + '</div>';
			eahtxt := eahtxt + '</div>';
		end;
		//
		if MOSForm_chbYears.checked then begin
			cctxt := cctxt + '<div class="MOS_year_chead_main" align="center" style="margin-bottom:2px;">';
			cctxt := cctxt + '<div class="MOS_year_chead" align="center" style="padding-top:5px; padding-bottom:5px; font-weight:bold; font-size:24px; width:' + IntToStr(pgwidth) + 'px; background-color: #' + gcolor[3] + ';">' + _('Caches') + '</div>';
			cctxt := cctxt + '</div>';
		end;
		UseLanguage('');
		//OUTTXT
		if MOSForm_chbMiniStat.checked then begin
			if MOSForm_chbYears.checked then begin
				if (MyEvents - MyAEvents) > 0 then
					outtxt := headertxt + statxt + outtxt + cctxt + couttxt + caouttxt + ehtxt + eouttxt + eaouttxt
				else if ((MyEvents - MyAEvents) = 0) and (MyEvents > 0) then
					outtxt := headertxt + statxt + outtxt + cctxt + couttxt + caouttxt + eahtxt + eaouttxt
				else
					outtxt := headertxt + statxt + outtxt + cctxt + couttxt + caouttxt;
			end
			else
				outtxt := headertxt + statxt + outtxt + couttxt + eouttxt + caouttxt + eaouttxt;
		end
		else begin
			if MOSForm_chbYears.checked then begin
				if (MyEvents - MyAEvents) > 0 then
					outtxt := headertxt + outtxt + cctxt + couttxt + caouttxt + ehtxt + eouttxt + eaouttxt
				else if ((MyEvents - MyAEvents) = 0) and (MyEvents > 0) then
					outtxt := headertxt + outtxt + cctxt + couttxt + caouttxt + eahtxt + eaouttxt
				else
					outtxt := headertxt + outtxt + cctxt + couttxt + caouttxt;
			end
			else 
				outtxt := headertxt + outtxt + couttxt + eouttxt + caouttxt + eaouttxt;
		end;
		//Version
		outtxt := outtxt + '<div class="MOS_version" style="text-align:center; font-weight:bold; color:#6484FF;"><a href="http://geoget.ararat.cz/doku.php/user:skript:myownstat" target="_blank">My Own Statistic</a>, version: ' + Verze + ' by <a href="http://www.drakmrak.cz" target="_blank">DrakMrak</a></div>' + CRLF;
		//
		outtxt := outtxt + '<div class="MOS_time" style="text-align:center; font-weight:bold; color:#6484FF;">Generation time: ' + FormatDateTime('hh:mm:ss.zzz',XTime - Now) + ' s </div>' + CRLF;
		//
		outtxt := outtxt + '<br /><br />';
		maxy := ((maxy div 10) * 10) + 10;
		//
		//YEAR
		if not MOSForm_chbYears.checked then begin
			outtxt := ReplaceString(outtxt, '%maxx%', IntToStr(maxx));
			outtxt := ReplaceString(outtxt, '%maxy%', IntToStr(maxy));
		end;
		//----
		outtxt := ReplaceString(outtxt, '%arch%', IntToStr(Arc + 1));
		if Arc > 0 then outtxt := ReplaceString(outtxt, '%show%', '''''') else outtxt := ReplaceString(outtxt, '%show%', 'none');
		//ShowHTMLMessage('test',IntToStr(maxx) + '/' +IntToStr(maxy) + ' - ' + outtxt);
		//--------------------------------------------------------------------------
	except
		if exceptiontype <> ErCustomError then ShowMessage(ExceptionToString(ExceptionType, ExceptionParam));
	finally
		if list.Count > 0 then list.SaveToFile(tmp);
		if (list.Count > 0) and silent then begin
			if MessBox(_('Caches that do not have correctly imported logs: ') + IntToStr(list.Count) + _(' caches') + CRLF + _('Would you like to see in GeoGet?'), _('Caches without all logs!!'), 4) = 6 then begin
				GeoListClear;
				GeoListFileAdd(tmp);
			end;
			DeleteFile(tmp);
		end;
		LCount := 0; GCount := 0; DCount := 0; {GnfCount := 0;} ACount := 0; DlyCnt := 0;
		list.Free;
		SetLength(YearlyMax, LCount);
		SetLength(Logs, LCount);
		SetLength(graf, GCount);
		//SetLength(grafnf, GnfCount);
		SetLength(disable, DCount);
		SetLength(archive, ACount);
		SetLength(Dayly, DlyCnt);	
	end;
	//--------------------------------------------------------------------------
	Result := myAnsiToUtf(outtxt);
end;
